//jakkHammer Tool - tink tink tink bye bricks
//Made by Cruxeis, BL_ID 35041

if(trim($Pref::jakkHammer::launchForce) $= "")
	$Pref::jakkHammer::launchForce = "5 5 5";
if(trim($Pref::jakkHammer::respawnTime) $= "")
	$Pref::jakkHammer::respawnTime = 8;
if(trim($Pref::jakkHammer::continueTime) $= "")
	$Pref::jakkHammer::continueTime = 500;
if(trim($Pref::jakkHammer::trustLevel) $= "")
	$Pref::jakkHammer::trustLevel = 1;

datablock audioProfile(jakkHammerUseSound)
{
	description = AudioClosestLooping3d;
	fileName 	= "./jakkHammerUseSound.wav";
	preload 	= true;
};

datablock particleData(jakkHammerParticle : hammerExplosionParticle)
{
	Colors[0] = "1 1 0 0.2";
};

datablock particleEmitterData(jakkHammerEmitter : hammerExplosionEmitter)
{
	particles = jakkHammerParticle;
};

datablock explosionData(jakkHammerExplosion : hammerExplosion)
{
	emitter[0] = jakkHammerEmitter;
	emitter[1] = hammerSparkEmitter;
};

datablock projectileData(jakkHammerProjectile)
{
	directDamage		= 50;
	directDamageType	= $DamageType::jakkHammer;
	radiusDamageType	= $DamageType::jakkHammer;
	Explosion			= jakkHammerExplosion;
	hasLight			= false;
	lifetime			= 500;
	lightColor			= "1 1 1";
	lightRadius			= 1;
	muzzleVelocity		= 200;
	uiName				= "Jakk Hammer Projectile";
	velInheritFactor	= 1;
};

datablock itemData(jakkHammerItem)
{
	canDrop				= true;
	category			= "Item";
	colorShiftColor		= "1 1 1 1";
	density				= 0.2;
	doColorShift		= false;
	elasticity			= 0.2;
	emap				= true;
	equipment			= true;
	friction			= 0.2;
	iconName			= "./jakkHammerIcon";
	image				= jakkHammerImage;
	mass				= 1;
	shapeFile			= "./jakkHammer.dts";
	uiName				= "Jakk Hammer";
};

datablock shapeBaseImageData(jakkHammerImage)
{
	ammo				= " ";
	armReady	 		= true;
	className 			= "WeaponImage";
	colorShiftColor		= "1 1 1 1";
	correctMuzzleVector = false;
	doColorShift		= false;
	doRetraction		= false;
	emap				= true;
	eyeOffset			= "0 0 0";
	firstPerson			= true;
	hasLight			= false;
	item				= jakkHammerItem;
	lightColor			= "1 1 1";
	lightRadius			= 0;
	lightType			= "NoLight";
	melee				= true;
	mountPoint			= 0;
	offset				= "-0.5255 0 -0.25";
	Projectile			= jakkHammerProjectile;
	projectileType		= Projectile;
	rotation			= eulerToMatrix("0 0 0");
	shapeFile			= "./jakkHammer.dts";
	
	stateName[0]					= "Activate";
	stateTransitionOnTimeout[0]		= "Ready";
	stateTimeoutValue[0]			= 0.2;
	stateSound[0]					= weaponSwitchSound;
	
	stateName[1]					= "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	
	stateName[2]					= "Fire";
	stateScript[2]					= "onFire";
	stateSound[2]					= jakkHammerUseSound;
	stateAllowImageChange[2]		= false;
	stateTransitionOnTimeout[2]		= "Reload";
	stateWaitForTimeout[3]			= true;
	stateTimeoutValue[2]			= 2;
	
	stateName[3]					= "Reload";
	stateAllowImageChange[3]		= true;
	stateTransitionOnTriggerUp[3]	= "Ready";
};

package jakkHammer {
	
function jakkHammerProjectile::onCollision(%this, %obj, %col, %pos, %fade, %normal)
{
	%sourceobj = %obj.sourceObject;
	%client = %obj.client;
	if(%col.getType() & $TypeMasks::fxBrickAlwaysObjectType)
	{
		if(getTrustLevel(%col, %sourceobj) < $Pref::jakkHammer::trustLevel)
			return %client.centerPrint(%col.getGroup().name SPC "\c0does not trust you enough to do that.", 1);
		if(!%col.getNumDownBricks())
		{
			%col.fakeKillBrick($Pref::jakkHammer::launchForce, $Pref::jakkHammer::respawnTime);
			return;
		}
		%col.fakeKillBrick($Pref::jakkHammer::launchForce, $Pref::jakkHammer::respawnTime);
		%col.fakeKillBrickStack(%sourceobj);
		%sourceobj.schedule(250, jakkHammerBounce);
	}
	parent::onCollision(%this, %obj, %col, %pos, %fade, %normal);
}

function jakkHammerImage::onFire(%this, %obj, %slot)
{
	parent::onFire(%this, %obj, %slot);
	%obj.noJakkHammer = false;
	%obj.playThread(2, shiftDown);
}

function jakkHammerImage::onMount(%this, %obj, %slot)
{
	%obj.playThread(1, armReadyBoth);
	parent::onMount(%this, %obj, %slot);
}

function jakkHammerImage::onUnMount(%this, %obj, %slot)
{
	%obj.playThread(2, root);
	parent::onUnMount(%this, %obj, %slot);
}

};

activatePackage(jakkHammer);

function fxDTSBrick::fakeKillBrickStack(%this, %obj)
{
	if(%obj.noJakkHammer)
		return;
	for(%i = 0; %i < %this.getNumDownBricks(); %i++)
	{
		%brick = %this.getDownBrick(%i);
		if(!%jakked[%brick] && !%brick.isFakeDead())
		{
			%brick.schedule($Pref::jakkHammer::continueTime, fakeKillBrick, $Pref::jakkHammer::launchForce, $Pref::jakkHammer::respawnTime);
			%brick.schedule($Pref::jakkHammer::continueTime, fakeKillBrickStack, %obj);
			%jakked[%brick] = true;
		}
	}
	if(%brick $= "")
		cancel(%obj.jakkHammerBounceSched);
}

function Player::jakkHammerBounce(%this)
{
	%this.playThread(2, plant);
	%this.jakkHammerBounceSched = %this.schedule(100, jakkHammerBounce);
}

function serverCmdCjakk(%client)
{
	if(!isObject(%obj = %client.player))
		return;
	if(!%obj.noJakkHammer)
	{
		%obj.noJakkHammer = true;
		cancel(%obj.jakkHammerBounceSched);
		%obj.client.centerPrint("\c3Jakk Hammer \c0cancelled.", 1);
	}
	else
		%obj.client.centerPrint("You aren't using your \c3Jakk Hammer!", 1);
}



	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	

